import os
import pickle

import numpy as np
import openai
import torch.utils.data
from sentence_transformers import SentenceTransformer
from torch.hub import download_url_to_file

openai.api_key = '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'
os.environ["TOKENIZERS_PARALLELISM"] = "false"

N_FACTS = 3

model = SentenceTransformer('sentence-transformers/all-MiniLM-L6-v2')

class Dataset(torch.utils.data.Dataset):
    def __init__(self):
        super().__init__()
        path_dataset = '../data/quotes_embs.pkl'
        if not os.path.exists(path_dataset):
            os.makedirs('../data', exist_ok=True)
            # download_url_to_file(
            #     'http://share.yellowrobot.xyz/1645110979-deep-learning-intro-2022-q1/quotes_embs.pkl',
            #     path_dataset,
            #     progress=True
            # )

        with open(path_dataset, 'rb') as fp:
            (
                self.final_quotes_sentences, self.final_authors, self.final_categories,
                self.vocabulary_keys, self.vocabulary_counts, self.authors_keys, self.categories_keys,
                self.embeddings
            ) = pickle.load(fp)

        # self.vocabulary_keys idx => word
        self.max_sentence_length = np.max([len(it) for it in self.final_quotes_sentences])
        self.np_embeddings = np.array(self.embeddings, dtype=np.float32)

    def __len__(self):
        return len(self.final_quotes_sentences)

    def __getitem__(self, idx):
        x_raw = np.array(self.final_quotes_sentences[idx], dtype=np.int64)
        x_words = [self.vocabulary_keys[it] for it in x_raw]
        sentence_full = ' '.join(x_words)
        sentence_full = sentence_full.replace(" ,", ",")
        sentence_full = sentence_full.replace(" .", ".")
        sentence_full = sentence_full.replace(" !", "!")
        sentence_full = sentence_full.replace(" ?", "?")
        sentence_full = sentence_full.replace(" -", "-")
        return sentence_full, self.np_embeddings[idx]


def encode_sentence(sentence):
    # TODO
    return None


def prompt_openai(messages, question, emb_question):
    # TODO
    return None

# TODO